#include <stdio.h>
#include <unistd.h>
#include <fcntl.h>
#include <linux/i2c-dev.h>
#include <linux/types.h>

#include "WCC.h"


// Bibli WiiClassic
//unsigned char _WCC_data->reception[6];
//char DY_init=0,DX_init=0,GY_init=0,GX_init=0;

int WiiClassicCom_Init(struct WCC_data * _WCC_data) {
    int file;
	int adapter_nr = 0; /* probably dynamically determined */
	char filename[20];
	int addr = 0x52; /* The I2C address */
	__u8 registre = 0x0; /* Device register to access */
	char buf[3];
	int i,j,ok;
	


	snprintf(filename, 19, "/dev/i2c-%d", adapter_nr);
	printf("\n%s\n",filename);
	file = open(filename, O_RDWR);
	if (file < 0) {
		printf("Ouverture %s : Echec\n",filename);
		close(file);
		/* ERROR HANDLING; you can check errno to see what went wrong */
		return -1;
	}
	printf("Ouverture %s : Ok\n",filename);
	
	
	addr=0x52;
	printf("adresse = %d\n",addr);



	if (ioctl(file, I2C_SLAVE, addr) < 0) {
		/* ERROR HANDLING; you can check errno to see what went wrong */
		printf("Erreur adresse\n");
		return -1;
	}
	printf("Adresse Ok\n");


	/* Using I2C Write, equivalent of 
	i2c_smbus_write_word_data(file, register, 0x6543) */

	// 1 ere init
	buf[0] = 0xF0;
	buf[1] = 0x55;
	i = write(file, buf, 2);
	if ( i != 2 ) {
		/* ERROR HANDLING: i2c transaction failed */
		printf("erreur ecriture : %d\n",i);
		close(file);
		return -1;
	}

	sleep(1);

	buf[0] = 0xFB;
	buf[1] = 0x00;
	i = write(file, buf, 2);
	if ( i != 2 ) {
		/* ERROR HANDLING: i2c transaction failed */
		printf("erreur ecriture : %d\n",i);
		close(file);
		return -1;
	}
	sleep(1);
	
	// Get Zeros for joysticks
	_WCC_data->file = file;
	_WCC_data->DX_init = 0;
	_WCC_data->DY_init = 0;
	_WCC_data->GX_init = 0;
	_WCC_data->GY_init = 0;
	
	sleep(1);
	// 1st reading
	WiiClassicCom_Read(_WCC_data);
	_WCC_data->DX_init = WCC_get_DX(_WCC_data);
	_WCC_data->DY_init = WCC_get_DY(_WCC_data);
	_WCC_data->GX_init = WCC_get_GX(_WCC_data);
	_WCC_data->GY_init = WCC_get_GY(_WCC_data);	
	
	return 1;
}

int WiiClassicCom_Read(struct WCC_data * _WCC_data){
    char buf[1],i;
    buf[0] = 0x00;
    i = write(_WCC_data->file, buf, 1);
    if ( i != 1 ) {
	    /* ERROR HANDLING: i2c transaction failed */
	    printf("erreur ecriture : %d\n",i);
	    close(_WCC_data->file);
	    return -1;
    }
    usleep(4000); // 4ms

    i = read(_WCC_data->file, _WCC_data->reception, 6);
    if (i != 6) {
	    /* ERROR HANDLING: i2c transaction failed */
	    //printf("Erreur Lecture : %d\n",i);
	    return -1;
    } 
    
    return 0;
}





// Fin bibliothèque WiiClassicCom
/*

char WiiClassic_Init(){
  DY_init=0;
  DX_init=0;
  GY_init=0;
  GX_init=0;
  if(!WiiClassicCom_Init()){
	  return 0;
  }
  Delay10KTCYx(0);
  if(!WiiClassicCom_Read(_WCC_data->reception)){
	  return 0;
  }
  
  DY_init = WCC_get_DY();
  DX_init = WCC_get_DX();
  GY_init = WCC_get_GY();
  GX_init = WCC_get_GX();
  
  return 1;
}
char WiiClassic_Read(){
   return WiiClassicCom_Read(_WCC_data->reception);
}
*/

int WCC_get_DX(struct WCC_data * _WCC_data){ // Test OK!
  return (int)((_WCC_data->reception[2] &0x80) >> 7 | 
         (_WCC_data->reception[1] &0xC0) >> 5 |
         (_WCC_data->reception[0] &0xC0) >> 3 ) - _WCC_data->DX_init;
}

int WCC_get_DY(struct WCC_data * _WCC_data){ // Test OK!
  return (int)(_WCC_data->reception[2] &0x1F) - _WCC_data->DY_init;
}

int WCC_get_GX(struct WCC_data * _WCC_data){ // Test OK!
  return (int)(_WCC_data->reception[0] &0x3F) - _WCC_data->GX_init;
}

int WCC_get_GY(struct WCC_data * _WCC_data){ // Test OK!
  return (int)(_WCC_data->reception[1] &0x3F) - _WCC_data->GY_init;
}

unsigned char WCC_get_L(struct WCC_data * _WCC_data){ // Test OK!
  return (_WCC_data->reception[3] &0xE0) >> 5 |
         (_WCC_data->reception[2] &0x60) >> 2 ;
}
unsigned char WCC_get_R(struct WCC_data * _WCC_data){ // Test OK!
  return (_WCC_data->reception[3] &0x1F) ;
}

unsigned char WCC_get_haut(struct WCC_data * _WCC_data){ //test Ok !
  return !(_WCC_data->reception[5] &0x01) ;
}
unsigned char WCC_get_bas(struct WCC_data * _WCC_data){ //test Ok !
  return !(_WCC_data->reception[4] &0x40) ;
}
unsigned char WCC_get_gauche(struct WCC_data * _WCC_data){ //test Ok !
  return !(_WCC_data->reception[5] &0x02) ;
}
unsigned char WCC_get_droite(struct WCC_data * _WCC_data){ //test Ok !
  return !(_WCC_data->reception[4] &0x80) ;
}

unsigned char WCC_get_X(struct WCC_data * _WCC_data){ // Test OK!
  return !(_WCC_data->reception[5] &0x08) ;
}
unsigned char WCC_get_Y(struct WCC_data * _WCC_data){ // Test OK!
  return !(_WCC_data->reception[5] &0x20) ;
}
unsigned char WCC_get_A(struct WCC_data * _WCC_data){ // Test OK!
  return !(_WCC_data->reception[5] &0x10) ;
}
unsigned char WCC_get_B(struct WCC_data * _WCC_data){ // Test OK!
  return !(_WCC_data->reception[5] &0x40) ;
}

unsigned char WCC_get_Lend(struct WCC_data * _WCC_data){ // Test OK!
  return !((_WCC_data->reception[4] &0x20) >> 5);
}
unsigned char WCC_get_Rend(struct WCC_data * _WCC_data){ // Test OK!
  return !((_WCC_data->reception[4] &0x02) >> 1);
}

unsigned char WCC_get_ZL(struct WCC_data * _WCC_data){
  return !((_WCC_data->reception[5] &0x80));
}
unsigned char WCC_get_ZR(struct WCC_data * _WCC_data){
  return !((_WCC_data->reception[5] &0x04));
}
unsigned char WCC_get_Home(struct WCC_data * _WCC_data){
  return !((_WCC_data->reception[4] &0x08));
}
unsigned char WCC_get_Select(struct WCC_data * _WCC_data){
  return !((_WCC_data->reception[4] &0x10));
}
unsigned char WCC_get_Start(struct WCC_data * _WCC_data){
  return !((_WCC_data->reception[4] &0x04));
}


